﻿using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Web.UI;


namespace CSSamples
{
    public partial class ClickEventOnAMarker : System.Web.UI.Page, ICallbackEventHandler
    {
        private readonly string[] markerIcons = new string[] { "marker_blue.gif", "marker.gif", "marker_gold.gif", "marker_green.gif" };

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");

                markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("../../theme/default/img/marker_blue.gif", 21, 25);
                markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                Map1.CustomOverlays.Add(markerOverlay);
                InMemoryMarkerOverlay markerOverlay1 = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
                string randomid = Guid.NewGuid().ToString();
                markerOverlay1.Features.Add(randomid, new Feature(new Vertex(-94.48242, 38.75977), randomid));
            }

            var callbackscript = @"function removecallback(arg, context) {" +
                ClientScript.GetCallbackEventReference(this, "arg", "ReceiveServerData", "context") + "}";
            ScriptManager.RegisterStartupScript(this, this.GetType(), "callbackscript", callbackscript, true);

        }

        public string GetCallbackResult()
        {
            return "";
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            InMemoryMarkerOverlay markerOverlay1 = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
            markerOverlay1.Features.Remove(eventArgument);
        }

    }
}
